/**
 */
package tools.descartes.dni.dnimm3ap.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dni.dnimm3ap.AdaptableEndPerformanceRepository;
import tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformanceRepository;
import tools.descartes.dni.dnimm3ap.AdaptableLinkPerformanceRepository;
import tools.descartes.dni.dnimm3ap.AdaptableLinkRepository;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformanceRepository;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfaceRepository;
import tools.descartes.dni.dnimm3ap.AdaptableNodeRepository;
import tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformanceRepository;
import tools.descartes.dni.dnimm3ap.AdaptationRepositories;
import tools.descartes.dni.dnimm3ap.DNIAPPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Adaptation Repositories</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getNodeRepository <em>Node Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getEndPerformanceRepository <em>End Performance Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getIntermediatePerformanceRepository <em>Intermediate Performance Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getSdnNodePerformanceRepository <em>Sdn Node Performance Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getNetworkInterfaceRepository <em>Network Interface Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getNetworkInterfacePerformanceRepository <em>Network Interface Performance Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getLinkRepository <em>Link Repository</em>}</li>
 *   <li>{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoriesImpl#getLinkPerformanceRepository <em>Link Performance Repository</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AdaptationRepositoriesImpl extends MinimalEObjectImpl.Container implements AdaptationRepositories {
	/**
	 * The cached value of the '{@link #getNodeRepository() <em>Node Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNodeRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableNodeRepository nodeRepository;

	/**
	 * The cached value of the '{@link #getEndPerformanceRepository() <em>End Performance Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndPerformanceRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableEndPerformanceRepository endPerformanceRepository;

	/**
	 * The cached value of the '{@link #getIntermediatePerformanceRepository() <em>Intermediate Performance Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntermediatePerformanceRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableIntermediatePerformanceRepository intermediatePerformanceRepository;

	/**
	 * The cached value of the '{@link #getSdnNodePerformanceRepository() <em>Sdn Node Performance Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSdnNodePerformanceRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableSdnNodePerformanceRepository sdnNodePerformanceRepository;

	/**
	 * The cached value of the '{@link #getNetworkInterfaceRepository() <em>Network Interface Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkInterfaceRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableNetworkInterfaceRepository networkInterfaceRepository;

	/**
	 * The cached value of the '{@link #getNetworkInterfacePerformanceRepository() <em>Network Interface Performance Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkInterfacePerformanceRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableNetworkInterfacePerformanceRepository networkInterfacePerformanceRepository;

	/**
	 * The cached value of the '{@link #getLinkRepository() <em>Link Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableLinkRepository linkRepository;

	/**
	 * The cached value of the '{@link #getLinkPerformanceRepository() <em>Link Performance Repository</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkPerformanceRepository()
	 * @generated
	 * @ordered
	 */
	protected AdaptableLinkPerformanceRepository linkPerformanceRepository;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptationRepositoriesImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DNIAPPackage.Literals.ADAPTATION_REPOSITORIES;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableNodeRepository getNodeRepository() {
		return nodeRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNodeRepository(AdaptableNodeRepository newNodeRepository, NotificationChain msgs) {
		AdaptableNodeRepository oldNodeRepository = nodeRepository;
		nodeRepository = newNodeRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY, oldNodeRepository, newNodeRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNodeRepository(AdaptableNodeRepository newNodeRepository) {
		if (newNodeRepository != nodeRepository) {
			NotificationChain msgs = null;
			if (nodeRepository != null)
				msgs = ((InternalEObject)nodeRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY, null, msgs);
			if (newNodeRepository != null)
				msgs = ((InternalEObject)newNodeRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY, null, msgs);
			msgs = basicSetNodeRepository(newNodeRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY, newNodeRepository, newNodeRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableEndPerformanceRepository getEndPerformanceRepository() {
		return endPerformanceRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEndPerformanceRepository(AdaptableEndPerformanceRepository newEndPerformanceRepository, NotificationChain msgs) {
		AdaptableEndPerformanceRepository oldEndPerformanceRepository = endPerformanceRepository;
		endPerformanceRepository = newEndPerformanceRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY, oldEndPerformanceRepository, newEndPerformanceRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEndPerformanceRepository(AdaptableEndPerformanceRepository newEndPerformanceRepository) {
		if (newEndPerformanceRepository != endPerformanceRepository) {
			NotificationChain msgs = null;
			if (endPerformanceRepository != null)
				msgs = ((InternalEObject)endPerformanceRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY, null, msgs);
			if (newEndPerformanceRepository != null)
				msgs = ((InternalEObject)newEndPerformanceRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY, null, msgs);
			msgs = basicSetEndPerformanceRepository(newEndPerformanceRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY, newEndPerformanceRepository, newEndPerformanceRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableIntermediatePerformanceRepository getIntermediatePerformanceRepository() {
		return intermediatePerformanceRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIntermediatePerformanceRepository(AdaptableIntermediatePerformanceRepository newIntermediatePerformanceRepository, NotificationChain msgs) {
		AdaptableIntermediatePerformanceRepository oldIntermediatePerformanceRepository = intermediatePerformanceRepository;
		intermediatePerformanceRepository = newIntermediatePerformanceRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY, oldIntermediatePerformanceRepository, newIntermediatePerformanceRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIntermediatePerformanceRepository(AdaptableIntermediatePerformanceRepository newIntermediatePerformanceRepository) {
		if (newIntermediatePerformanceRepository != intermediatePerformanceRepository) {
			NotificationChain msgs = null;
			if (intermediatePerformanceRepository != null)
				msgs = ((InternalEObject)intermediatePerformanceRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY, null, msgs);
			if (newIntermediatePerformanceRepository != null)
				msgs = ((InternalEObject)newIntermediatePerformanceRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY, null, msgs);
			msgs = basicSetIntermediatePerformanceRepository(newIntermediatePerformanceRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY, newIntermediatePerformanceRepository, newIntermediatePerformanceRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableSdnNodePerformanceRepository getSdnNodePerformanceRepository() {
		return sdnNodePerformanceRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSdnNodePerformanceRepository(AdaptableSdnNodePerformanceRepository newSdnNodePerformanceRepository, NotificationChain msgs) {
		AdaptableSdnNodePerformanceRepository oldSdnNodePerformanceRepository = sdnNodePerformanceRepository;
		sdnNodePerformanceRepository = newSdnNodePerformanceRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY, oldSdnNodePerformanceRepository, newSdnNodePerformanceRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSdnNodePerformanceRepository(AdaptableSdnNodePerformanceRepository newSdnNodePerformanceRepository) {
		if (newSdnNodePerformanceRepository != sdnNodePerformanceRepository) {
			NotificationChain msgs = null;
			if (sdnNodePerformanceRepository != null)
				msgs = ((InternalEObject)sdnNodePerformanceRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY, null, msgs);
			if (newSdnNodePerformanceRepository != null)
				msgs = ((InternalEObject)newSdnNodePerformanceRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY, null, msgs);
			msgs = basicSetSdnNodePerformanceRepository(newSdnNodePerformanceRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY, newSdnNodePerformanceRepository, newSdnNodePerformanceRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableNetworkInterfaceRepository getNetworkInterfaceRepository() {
		return networkInterfaceRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNetworkInterfaceRepository(AdaptableNetworkInterfaceRepository newNetworkInterfaceRepository, NotificationChain msgs) {
		AdaptableNetworkInterfaceRepository oldNetworkInterfaceRepository = networkInterfaceRepository;
		networkInterfaceRepository = newNetworkInterfaceRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY, oldNetworkInterfaceRepository, newNetworkInterfaceRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNetworkInterfaceRepository(AdaptableNetworkInterfaceRepository newNetworkInterfaceRepository) {
		if (newNetworkInterfaceRepository != networkInterfaceRepository) {
			NotificationChain msgs = null;
			if (networkInterfaceRepository != null)
				msgs = ((InternalEObject)networkInterfaceRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY, null, msgs);
			if (newNetworkInterfaceRepository != null)
				msgs = ((InternalEObject)newNetworkInterfaceRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY, null, msgs);
			msgs = basicSetNetworkInterfaceRepository(newNetworkInterfaceRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY, newNetworkInterfaceRepository, newNetworkInterfaceRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableNetworkInterfacePerformanceRepository getNetworkInterfacePerformanceRepository() {
		return networkInterfacePerformanceRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNetworkInterfacePerformanceRepository(AdaptableNetworkInterfacePerformanceRepository newNetworkInterfacePerformanceRepository, NotificationChain msgs) {
		AdaptableNetworkInterfacePerformanceRepository oldNetworkInterfacePerformanceRepository = networkInterfacePerformanceRepository;
		networkInterfacePerformanceRepository = newNetworkInterfacePerformanceRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY, oldNetworkInterfacePerformanceRepository, newNetworkInterfacePerformanceRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNetworkInterfacePerformanceRepository(AdaptableNetworkInterfacePerformanceRepository newNetworkInterfacePerformanceRepository) {
		if (newNetworkInterfacePerformanceRepository != networkInterfacePerformanceRepository) {
			NotificationChain msgs = null;
			if (networkInterfacePerformanceRepository != null)
				msgs = ((InternalEObject)networkInterfacePerformanceRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY, null, msgs);
			if (newNetworkInterfacePerformanceRepository != null)
				msgs = ((InternalEObject)newNetworkInterfacePerformanceRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY, null, msgs);
			msgs = basicSetNetworkInterfacePerformanceRepository(newNetworkInterfacePerformanceRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY, newNetworkInterfacePerformanceRepository, newNetworkInterfacePerformanceRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableLinkRepository getLinkRepository() {
		return linkRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLinkRepository(AdaptableLinkRepository newLinkRepository, NotificationChain msgs) {
		AdaptableLinkRepository oldLinkRepository = linkRepository;
		linkRepository = newLinkRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY, oldLinkRepository, newLinkRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLinkRepository(AdaptableLinkRepository newLinkRepository) {
		if (newLinkRepository != linkRepository) {
			NotificationChain msgs = null;
			if (linkRepository != null)
				msgs = ((InternalEObject)linkRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY, null, msgs);
			if (newLinkRepository != null)
				msgs = ((InternalEObject)newLinkRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY, null, msgs);
			msgs = basicSetLinkRepository(newLinkRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY, newLinkRepository, newLinkRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableLinkPerformanceRepository getLinkPerformanceRepository() {
		return linkPerformanceRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLinkPerformanceRepository(AdaptableLinkPerformanceRepository newLinkPerformanceRepository, NotificationChain msgs) {
		AdaptableLinkPerformanceRepository oldLinkPerformanceRepository = linkPerformanceRepository;
		linkPerformanceRepository = newLinkPerformanceRepository;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY, oldLinkPerformanceRepository, newLinkPerformanceRepository);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLinkPerformanceRepository(AdaptableLinkPerformanceRepository newLinkPerformanceRepository) {
		if (newLinkPerformanceRepository != linkPerformanceRepository) {
			NotificationChain msgs = null;
			if (linkPerformanceRepository != null)
				msgs = ((InternalEObject)linkPerformanceRepository).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY, null, msgs);
			if (newLinkPerformanceRepository != null)
				msgs = ((InternalEObject)newLinkPerformanceRepository).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY, null, msgs);
			msgs = basicSetLinkPerformanceRepository(newLinkPerformanceRepository, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY, newLinkPerformanceRepository, newLinkPerformanceRepository));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY:
				return basicSetNodeRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY:
				return basicSetEndPerformanceRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY:
				return basicSetIntermediatePerformanceRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY:
				return basicSetSdnNodePerformanceRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY:
				return basicSetNetworkInterfaceRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY:
				return basicSetNetworkInterfacePerformanceRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY:
				return basicSetLinkRepository(null, msgs);
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY:
				return basicSetLinkPerformanceRepository(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY:
				return getNodeRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY:
				return getEndPerformanceRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY:
				return getIntermediatePerformanceRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY:
				return getSdnNodePerformanceRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY:
				return getNetworkInterfaceRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY:
				return getNetworkInterfacePerformanceRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY:
				return getLinkRepository();
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY:
				return getLinkPerformanceRepository();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY:
				setNodeRepository((AdaptableNodeRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY:
				setEndPerformanceRepository((AdaptableEndPerformanceRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY:
				setIntermediatePerformanceRepository((AdaptableIntermediatePerformanceRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY:
				setSdnNodePerformanceRepository((AdaptableSdnNodePerformanceRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY:
				setNetworkInterfaceRepository((AdaptableNetworkInterfaceRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY:
				setNetworkInterfacePerformanceRepository((AdaptableNetworkInterfacePerformanceRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY:
				setLinkRepository((AdaptableLinkRepository)newValue);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY:
				setLinkPerformanceRepository((AdaptableLinkPerformanceRepository)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY:
				setNodeRepository((AdaptableNodeRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY:
				setEndPerformanceRepository((AdaptableEndPerformanceRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY:
				setIntermediatePerformanceRepository((AdaptableIntermediatePerformanceRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY:
				setSdnNodePerformanceRepository((AdaptableSdnNodePerformanceRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY:
				setNetworkInterfaceRepository((AdaptableNetworkInterfaceRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY:
				setNetworkInterfacePerformanceRepository((AdaptableNetworkInterfacePerformanceRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY:
				setLinkRepository((AdaptableLinkRepository)null);
				return;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY:
				setLinkPerformanceRepository((AdaptableLinkPerformanceRepository)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NODE_REPOSITORY:
				return nodeRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__END_PERFORMANCE_REPOSITORY:
				return endPerformanceRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__INTERMEDIATE_PERFORMANCE_REPOSITORY:
				return intermediatePerformanceRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__SDN_NODE_PERFORMANCE_REPOSITORY:
				return sdnNodePerformanceRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_REPOSITORY:
				return networkInterfaceRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__NETWORK_INTERFACE_PERFORMANCE_REPOSITORY:
				return networkInterfacePerformanceRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_REPOSITORY:
				return linkRepository != null;
			case DNIAPPackage.ADAPTATION_REPOSITORIES__LINK_PERFORMANCE_REPOSITORY:
				return linkPerformanceRepository != null;
		}
		return super.eIsSet(featureID);
	}

} //AdaptationRepositoriesImpl
